package com.usky.iot.service;

import com.usky.iot.domain.PmWorkContent;
import com.usky.common.mybatis.core.CrudService;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.List;

/**
 * <p>
 * 工作内容表 服务类
 * </p>
 *
 * @author fu
 * @since 2024-05-20
 */
public interface PmWorkContentService extends CrudService<PmWorkContent> {

    /**
     * 清空报告内容
     * @param reportId 报告id
     */
    void deleteContent(Integer reportId);

    /**
     * 报告记录中查询项目名与id
     * @param startDate 开始时间
     * @param endDate 结束时间
     * @param projectName 项目名
     * @param projectAscription 查询标识（1：我负责的；2：抄送我的）
     * @return
     */
    List<PmWorkContent> projectQuery(String startDate, String endDate, String projectName, Integer projectAscription);


}
